PingAuthorize API Reference

Create Trust Framework Definition (Parent Type and Full Name)

POST {{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}

The POST /trust-framework/{{definitionType}}/{{fullName}} operation creates a child definition, specifying the parent type and full name in the request URL. The request must provide either a branch ID or a snapshot ID in the request URL.

Prerequisites

Query parameters
Query parameter Description

branch

Branch ID or name

snapshot

Snapshot ID

page

Page number of results

page-size

Number of results per page

Request Model

For property descriptions, refer to Authorization Trust Framework definition data model.

Property Type? Required?

version

String

Required

type

Object

Required

name

String

Required

fullName

Object

Required

description

String

Required

processor

Object

Required

parentId

String

Required

numberOfChildren

String

Required

permissions

Object

Required

properties

Object

Required

Headers

Content-Type      application/json

x-user-id      {{userId}}

Body

raw ( application/json )

{
    "type": "ATTRIBUTE",
    "name": "Test Child Definition2",
    "fullName": "Test Definition2.Test Child Definition2"
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}' \
--header 'x-user-id: {{userId}}' \
--header 'Content-Type: application/json' \
--data '{
    "type": "ATTRIBUTE",
    "name": "Test Child Definition2",
    "fullName": "Test Definition2.Test Child Definition2"
}'
var options = new RestClientOptions("{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("x-user-id", "{{userId}}");
request.AddHeader("Content-Type", "application/json");
var body = @"{" + "\n" +
@"    ""type"": ""ATTRIBUTE""," + "\n" +
@"    ""name"": ""Test Child Definition2""," + "\n" +
@"    ""fullName"": ""Test Definition2.Test Child Definition2""" + "\n" +
@"}" + "\n" +
@"" + "\n" +
@"" + "\n" +
@"";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}"
  method := "POST"

  payload := strings.NewReader(`{
    "type": "ATTRIBUTE",
    "name": "Test Child Definition2",
    "fullName": "Test Definition2.Test Child Definition2"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("x-user-id", "{{userId}}")
  req.Header.Add("Content-Type", "application/json")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}} HTTP/1.1
Host: {{apiPath}}
x-user-id: {{userId}}
Content-Type: application/json

{
    "type": "ATTRIBUTE",
    "name": "Test Child Definition2",
    "fullName": "Test Definition2.Test Child Definition2"
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"type\": \"ATTRIBUTE\",\n    \"name\": \"Test Child Definition2\",\n    \"fullName\": \"Test Definition2.Test Child Definition2\"\n}\n\n\n");
Request request = new Request.Builder()
  .url("{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}")
  .method("POST", body)
  .addHeader("x-user-id", "{{userId}}")
  .addHeader("Content-Type", "application/json")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "x-user-id": "{{userId}}",
    "Content-Type": "application/json"
  },
  "data": JSON.stringify({
    "type": "ATTRIBUTE",
    "name": "Test Child Definition2",
    "fullName": "Test Definition2.Test Child Definition2"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}',
  'headers': {
    'x-user-id': '{{userId}}',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    "type": "ATTRIBUTE",
    "name": "Test Child Definition2",
    "fullName": "Test Definition2.Test Child Definition2"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}"

payload = json.dumps({
  "type": "ATTRIBUTE",
  "name": "Test Child Definition2",
  "fullName": "Test Definition2.Test Child Definition2"
})
headers = {
  'x-user-id': '{{userId}}',
  'Content-Type': 'application/json'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'x-user-id' => '{{userId}}',
  'Content-Type' => 'application/json'
));
$request->setBody('{\n    "type": "ATTRIBUTE",\n    "name": "Test Child Definition2",\n    "fullName": "Test Definition2.Test Child Definition2"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["x-user-id"] = "{{userId}}"
request["Content-Type"] = "application/json"
request.body = JSON.dump({
  "type": "ATTRIBUTE",
  "name": "Test Child Definition2",
  "fullName": "Test Definition2.Test Child Definition2"
})

response = http.request(request)
puts response.read_body
let parameters = "{\n    \"type\": \"ATTRIBUTE\",\n    \"name\": \"Test Child Definition2\",\n    \"fullName\": \"Test Definition2.Test Child Definition2\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/trust-framework/{{definitionType}}/{{fullName}}?branch={{branchId}}&snapshot={{snapshotId}}")!,timeoutInterval: Double.infinity)
request.addValue("{{userId}}", forHTTPHeaderField: "x-user-id")
request.addValue("application/json", forHTTPHeaderField: "Content-Type")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

201 Created

{
    "objectType": "AttributeDefinition",
    "id": "c0f08528-9f95-4b69-a466-7939727fb2f2",
    "version": "dcf8004b-8c1b-4e42-a7f2-c642d4479bd2",
    "type": "ATTRIBUTE",
    "name": "Test Child Definition2",
    "fullName": "Test Definition2.Test Child Definition2.Test Child Definition2",
    "description": "",
    "parentId": "50a34c29-18ba-4a44-9b9b-8034af78f6fe",
    "numberOfChildren": 0,
    "valueType": "STRING",
    "defaultValue": null,
    "repetitionSource": null,
    "cacheConfig": {
        "timeToLive": 0,
        "scopeAttributeId": null,
        "strategy": "NO_CACHING"
    },
    "secret": false,
    "permissions": {
        "inherit": true,
        "rolePermissions": []
    },
    "resolvers": [],
    "querySettings": null,
    "valueProcessor": null,
    "properties": []
}